
c global specifiactions

	include 'params.h'

c space variables (**: further specifications are provided at the end of the file)

	real mu(nx,nz)			!physical parameter mu (shear modulus) defined in every point of the grid
	real lam(nx,nz)			!physical parameter lambda defined in every point of the grid
	real dmx(0:nx,0:nx)		!array with the values for the derivative operator (x case)
	real dmz(0:nz,0:nz)		!array with the values for the derivative operator (z case)
	real w(3,5,nx,nz)		!array with the values of the variables' fields (sxx, v, etc.) **
	real rho(nx,nz)			!density defined in every point of the grid
	real rho0,vsa,vp0		!constants used to build the parameter fields mu,lam,rho

	real xs(nx)				!vector with the positions in the x-axis
	real zs(nz)				!vector with the positions in the x-axis

	integer model_type		!identifier of the type of model used **

	integer tord			!time-order of the computation

c source 

	integer source_type		!identifier of the type of source used **
	real so(2*maxnt)		!time part of the decomposition of the source value
	integer isx,isz			!position of the source in the grid
	real gauss(nx,nz)		!spatial part of the decomposition of the source value
	real alpha				!value of the half-width opf the source

c seismograms

	real seisx(maxnr*maxnt)	!vector where the values for plotting seismograms are plotted (x case)
	real seisz(maxnr*maxnt)	!vector where the values for plotting seismograms are plotted (z case)
	real dx,dt				!values of the grid spacing and timestep
	integer ssamp			!snapshot sampling in timesteps

c Files

	character*50 seisfile,modelfile


	common /creal/ dx,dz,dt,so,aa,vs0,vp0,rho0,mu,w,
     &                 lam,rho,dmx,dmz,gauss,
     &                 alpha,xmax,zmax,fact,xxs,zzs,
     &                 as,bs,gammax,gammaz,xs,zs

	common /cint/ nt,it,isx,isz,source_type,icomp,ibound,
     &                ixa,ixe,irec,isamp,izrec,it0,
     &	              model_type,icheck,ssamp,tord,nop

	common /cchar/ seisfile,modelfile



c **: Additional explanation of some variables
c *******************************************************
c w(a,b,c,d):	a:The number of the Runge-Kutta substep
c				b:The identifier of the five variables
c					1:velocity in x (vx)
c					2:velocity in z (vz)
c					3:bulk stress in x (sxx)
c					4:bulk stress in z (szz)
c					5:shear stress (sxz)
c				c:index for the x component
c				d:index for the z component
c
c *******************************************************
c model_type:	1=homogeneous model
c				2=3-layered horizontal model
c
c *******************************************************
c source_type:	1=gaussian source in vx
c				2=gaussian source in vz
c				3=gaussian source in sxx and szz
c				4=gaussian source in sxz
c
c *******************************************************